package zero1hd.rhythmbullet.graphics.ui.components;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.assets.AssetManager;
import com.badlogic.gdx.graphics.Color;
import com.badlogic.gdx.graphics.OrthographicCamera;
import com.badlogic.gdx.graphics.g2d.Batch;
import com.badlogic.gdx.math.MathUtils;
import com.badlogic.gdx.scenes.scene2d.Group;
import com.badlogic.gdx.utils.Disposable;

import zero1hd.rhythmbullet.graphics.meshes.TitleBarMesh;

public class TitleBarVisualizer extends Group implements Disposable {
	private Visualizer hvisual;
	private TitleBarMesh background;
	
	public TitleBarVisualizer(AssetManager assets, OrthographicCamera camera) {
		if (assets == null) throw new  NullPointerException("TitleBarVisualizer requires assets manager... ITS NULL YOU FOOL");
		setSize((float) Math.sqrt(Gdx.graphics.getWidth()*Gdx.graphics.getWidth() + Gdx.graphics.getHeight()*Gdx.graphics.getHeight()), Gdx.graphics.getHeight()*0.3f);
		hvisual = new Visualizer();
		addActor(hvisual);
		debug();
		background = new TitleBarMesh();
		background.setHeight((int) MathUtils.round(Gdx.graphics.getHeight()*0.3f));
		setRotation((float) (MathUtils.radiansToDegrees*Math.atan2(Gdx.graphics.getHeight()-background.getHeight(), Gdx.graphics.getWidth())));
		background.setCam(camera);
		
		hvisual.setWidth(getWidth());
		hvisual.setHeight(Gdx.graphics.getHeight()*0.3f);
		hvisual.getVis().flip();
	}
	
	@Override
	public void act(float delta) {
		super.act(delta);
	}
	
	@Override
	public void draw(Batch batch, float parentAlpha) {
		background.draw();
		batch.end();
		batch.begin();
		super.draw(batch, parentAlpha);
	}
	
	public Visualizer getHvisual() {
		return hvisual;
	}

	@Override
	public void dispose() {
	}
	
	@Override
	public void setColor(Color color) {
		super.setColor(color);
	}
	
	@Override
	public void setColor(float r, float g, float b, float a) {
		super.setColor(r, g, b, a);
	}
}
